import { useState } from 'react'

const App = () => {
  // tallenna napit omaan tilaansa
  const [ good, setGood ] = useState(0)
  const [ neutral, setNeutral ] = useState(0)
  const [ bad, setBad ] = useState(0)

  const handleGoodClick = () => {
    setGood(good + 1)
    console.log("Increasing Good reviews by one, total Good reviews:", good)
  }

  const handleNeutralClick = () => {
    setNeutral(neutral + 1)
    console.log("Increasing Neutral reviews by one, total Neutral reviews:", neutral)
  }

  const handleBadClick = () => {
    setBad(bad + 1)
    console.log("Increasing Bad reviews by one, total Bad reviews:", bad)
  }


  return (
    <div>
      <h1>Give feedback</h1>
      <Button handleClick={handleGoodClick} name="Good" />
      <Button handleClick={handleNeutralClick} name="Neutral" />
      <Button handleClick={handleBadClick} name="Bad" />
      <h1>Statistics</h1>
      <Statistics good = {good} neutral = {neutral} bad = {bad} />
    </div>
  )
}

const Statistics = ( {good, neutral, bad} ) => {
  const total = good + neutral + bad
  console.log("Total is", total)
  if (total === 0 ) {
    return (
      <p>No feedback given</p>
    )
  }
  return (
    <table>
      <tbody>
        <StatisticLine text="good" value={good} type="" />
        <StatisticLine text="neutral" value={neutral} type=""/>
        <StatisticLine text="bad" value={bad} type=""/>
        <StatisticLine text="all" value={total} />
        <StatisticLine text="average" value={(good - bad) / (total)} type=""/>
        <StatisticLine text="positive" value={good / (total) * 100} type="%"/>
      </tbody>
    </table>
  )
}

const Button = (props) => (
  <button onClick={props.handleClick}>
    {props.name}
  </button>
  )

const StatisticLine = ( {text, value, type} ) => {
    return (
      <tr>
        <td>{text}</td>
        <td>{value}{type}</td>
      </tr>
    )
}

export default App